type 'a arbre = Empty | Node of 'a arbre * 'a * 'a arbre;;

module type File = 
sig
  exception FileVide
  type 'a file
  val mkempty: unit -> 'a file
  val enqueue: 'a -> 'a file -> 'a file
  val dequeue: 'a file -> 'a * 'a file
  val isempty: 'a file -> bool
end;;

module ParcLarg =
  functor (F:File) ->
  struct
    let rec bf f p = if F.isempty f then List.rev p
                     else let (a,f') = F.dequeue f 
                          in match a with
                               Empty       -> bf f' p
                             | Node(g,v,d) -> bf (F.enqueue d (F.enqueue g f')) (v::p)
    let parclarg a = bf (F.enqueue a (F.mkempty())) []
  end;;

let b=
  Node
   (Node (Node (Empty, 4, Empty), 2, Node (Empty, 5, Empty)), 1,
    Node (Node (Empty, 6, Empty), 3, Node (Empty, 7, Empty)));;

(* et maintenant, testons le tout! *)

module PCL = ParcLarg(Circlist);;
 List.iter (fun x->print_int x; print_newline()) (PCL.parclarg b);;
module PDL = ParcLarg(File2listes);;
 List.iter (fun x->print_int x; print_newline()) (PDL.parclarg b);;
